\ GetMACaddress.fth - get MAC address from Windows

((
Copyright (c) 2005
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
))


#define MAX_ADAPTER_NAME_LENGTH 256
#define MAX_ADAPTER_DESCRIPTION_LENGTH 128
#define MAX_ADAPTER_ADDRESS_LENGTH 8
#define DEFAULT_MINIMUM_ENTITIES 32
#define MAX_HOSTNAME_LEN 128
#define MAX_DOMAIN_NAME_LEN 128
#define MAX_SCOPE_ID_LEN 256
#define BROADCAST_NODETYPE 1
#define PEER_TO_PEER_NODETYPE 2
#define MIXED_NODETYPE 4
#define HYBRID_NODETYPE 8

#16 constant /IP_ADDRESS_STRING
#16 constant /IP_MASK_STRING

struct /IP_ADDR_STRING	\ -- len ; 40/48
  _ptr field ias.Next				// 4/8
  /IP_ADDRESS_STRING field ias.IpAddress  	// 16 bytes
  /IP_MASK_STRING field ias.IpMask		// 16 bytes
  _dword field ias.Context			// 4
  aligned
end-struct					// 40/48 bytes

\ *P Returned adapter information is in the form of this
\ ** structure, whose first element is a pointer to the next
\ ** one in the list terminated by a zero in the first DWORD
\ ** of the last valid structure.
\ *[
struct /IP_ADAPTER_INFO	\ -- len ; 640/704
  _ptr a-field iai.Next					// 4/8
  _dword a-field iai.ComboIndex				// 4
  MAX_ADAPTER_NAME_LENGTH 4 + a-field iai.AdapterName	// 256+4=260	UID
  MAX_ADAPTER_DESCRIPTION_LENGTH 4 + a-field iai.Description	// 128+4=132	Text
  _uint a-field iai.AddressLength			// 4		#bytes=6
  MAX_ADAPTER_ADDRESS_LENGTH a-field iai.Address	// 8 @ +404	MAC address
  _dword a-field iai.Index				// 4
  _uint a-field iai.Type				// 4
  _uint a-field iai.DhcpEnabled				// 4
  _ptr a-field iai.CurrentIpAddress			// 4/8 ; ptr
  /IP_ADDR_STRING a-field iai.IpAddressList		// 40/48
  /IP_ADDR_STRING a-field iai.GatewayList		// 40/48
  /IP_ADDR_STRING a-field iai.DhcpServer		// 40/48
  _bool a-field iai.HaveWins				// 4
  /IP_ADDR_STRING a-field iai.PrimaryWinsServer		// 40/48
  /IP_ADDR_STRING a-field iai.SecondaryWinsServer	// 40/48
  _time_t a-field iai.LeaseObtained			// 4/8
  _time_t a-field iai.LeaseExpires			// 4/8
end-struct						//  640/704
\ *]

((
DWORD GetAdaptersInfo(
  void pAdapterInfo,    // buffer to receive data
  PULONG pOutBufLen                 // size of data returned
);

Parameters
  pAdapterInfo
    Pointer to a buffer that, on successful return, receives a linked
    list of IP_ADAPTER_INFO structures.
  pOutBufLen
    Pointer to a ULONG variable that contains the size of the buffer
    pointed to by the pAdapterInfo parameter. If this size is
    insufficient to hold the adapter information, GetAdaptersInfo
    fills in this variable with the required size, and returns an
    error code of ERROR_BUFFER_OVERFLOW (#111).
Return Values
  If the function succeeds, the return value is ERROR_SUCCESS (0).
))


\ ************
\ *S Interface
\ ************

library: iphlpapi.dll

Extern: DWORD PASCAL GetAdaptersInfo(  void * pAdapterInfo, DWORD * pOutBufLen );

: GetMACaddress		\ buff --
\ *G Return the first MAC address into the given six-byte buffer.
  { | buff[ /IP_ADAPTER_INFO ] len[ cell ] -- }
  /IP_ADAPTER_INFO len[ !
  buff[ len[ GetAdaptersInfo drop
\ cr len[ l@ .dword 
\ cr buff[ /IP_ADAPTER_INFO dump
  buff[ iai.Address swap 6 cmove
;

: GetMacInfo	\ -- buff|0
\ *G Return a buffer containing adapter information for all adapters
\ ** in the system. If the return value is 0, an error occurred. The
\ ** buffer contains a set of IP_ADAPTER_INFO structures. The buffer
\ ** was allocated from the heap and must be *\fo{FREE}d after use.
  { | pbuff len[ cell ] -- }
  /IP_ADAPTER_INFO allocate
  if  drop 0  exit  endif
  -> pbuff  /IP_ADAPTER_INFO len[ !
  pbuff len[ GetAdaptersInfo 0=
  if  pbuff exit  endif
  pbuff free drop
  len[ @ 0=
  if  0 exit  endif
  len[ @ allocate
  if  drop  0  exit  endif
  -> pbuff
  pbuff len[ GetAdaptersInfo 0=
  if  pbuff exit  endif
  pbuff free drop  0
;


\ ********
\ *S Tests
\ ********

((
#1024 buffer: rxdata
variable rxlen  /IP_ADAPTER_INFO rxlen !

8 buffer: pMAC
pMAC GetMACaddress
))


