\ Hello World For Windows

\ ============================================
\ Declare any API functions required which are
\ not in the Kernel by default                
\ ============================================

EXTERN: int PASCAL DrawText( HDC, LPCTSTR, int, LPRECT, UINT );
EXTERN: HANDLE PASCAL BeginPaint( HANDLE, void * );
EXTERN: int PASCAL GetClientRect( HANDLE, void * );
EXTERN: int PASCAL EndPaint( HANDLE, void * );


\ =====================================================
\ Define a Window resource Template for the Main Window
\ =====================================================

#define IDW_MAINWINDOW $0ACE

IDW_MAINWINDOW WINDOW 0, 0, 300, 100
BEGIN
   Caption         "VFX Forth For Win32 and Win64 - Hello World"
   Style           WS_POPUP | WS_BORDER | WS_SYSMENU |
                   WS_CAPTION | WS_THICKFRAME | WS_MINIMIZEBOX |
                   WS_MAXIMIZEBOX | WS_CLIPSIBLINGS | WS_VISIBLE
   ClassStyle      CS_HREDRAW | CS_VREDRAW
   Icon            IDI_APPLICATION
   Cursor          IDC_ARROW
   Brush           WHITE_BRUSH
   Menu            NULL
   WndProc         TestWindowProc
END


\ ================================================================ )
\ The Window Procedure. All messages are passed back to Windows    )
\ except for the WM_PAINT. In response to WM_PAINT the word        )
\ PAINTSCREEN is called which will use the API call DrawText() to  )
\ write "Hello world" in the screen center.                        )
\ ================================================================ )

: PaintScreen	\ hWnd --
  { hWnd | HDC ps[ PAINTSTRUCT ] rect[ RECT ] }

  hWnd ps[ BeginPaint -> hdc

  hWnd rect[ GetClientRect drop

  hdc
  Z" Hello World"
  dup zcount nip
  rect[
  DT_CENTER DT_VCENTER or DT_SINGLELINE or
  DrawText drop

  hWnd ps[ EndPaint drop

;

: TestWindowProc	\ hWnd uMessage wParam lParam -- res
  { hWnd uMessage wParam lParam }

  uMessage case
    WM_PAINT of hWnd PaintScreen 0 endof
    drop hWnd uMessage wParam lParam DefWindowProc
  end-case

;


\ ================================================================
\ The start definition. This word will create the window from
\ the template defined above. A message box is displayed on error.
\ ================================================================

: Run		\ --
  IDW_MAINWINDOW Resource::CreateParentWindow
  ?dup if
    cr ." Demo Window Active, handle = $" .dword
  else
    HWND_DESKTOP
    Z" Failed to create Demo Window"
    Z" Error"
    MB_OK
    MessageBox drop
  then
;

\ ================================================================

cr cr .( Type Run<cr> to see the demo ) cr cr
