(*
 * LANGUAGE    : Forth
 * PROJECT     : Working on MPE and iForth
 * DESCRIPTION : iForth OS dependent functions for the jack sound interface
 * CATEGORY    : Realtime Audio tool
 * AUTHOR      : Hanno Schwalm
 * LAST CHANGE : 2009-08-12 02:32:22 corrected connections path
 *)

JACKAUDIO DEFINITIONS
CREATE $FJACKSYSFILE $100 ALLOT
: (#.R)		( u r -- addr n )	BASE @ >R DECIMAL >R S>D R> (UD.R) R> BASE ! ;
: ($.R)		( u r -- addr n )	BASE @ >R HEX >R S>D R> (UD.R) R> BASE ! ;
: @LATEST-NAME	( -- addr )		@LATEST ;
: .NAMEHEADER	( addr -- )		COUNT TYPE ;
: .LEVEL	( f1 -- )		BASE @ DECIMAL PRECISION 4 SET-PRECISION 8 F.R SET-PRECISION BASE ! ;
[UNDEFINED] PLACE	[IF] : PLACE	PACK DROP ;			[THEN]
: top-mem	( -- addr )		MAIN-UP  CP UP - + @ ;

typedef int jack_time

:NONAME	( -- )	\ reads the current filesystem name to $FJACKSYSFILE;
	S" IFORTH" SEARCH-ENV$
	IF	$FJACKSYSFILE PLACE  S" /include/fjack/" $FJACKSYSFILE PLACE+
	ELSE	2DROP S" include/fjack/" $FJACKSYSFILE PLACE
	THEN
	S" sysfiles/" $FJACKSYSFILE PLACE+
	WINDOWS?
	IF	$FJACKSYSFILE COUNT BOUNDS ?DO I C@ [CHAR] / = IF [CHAR] \ I C! THEN LOOP
	ELSE	$FJACKSYSFILE COUNT BOUNDS ?DO I C@ [CHAR] \ = IF [CHAR] / I C! THEN LOOP
	THEN ; DUP EXECUTE AtCold

