#! /bin/bash

VFXBINFILE=VfxForth_x64_lin.elf

# Remove old link and library
pushd /usr/lib
if [ -e vfxsupp64.so.1.0.1 ]; then
   sudo rm vfxsupp64.so.1.0.1
   sudo rm vfxsupp64.so.1
fi
popd

# Install the compiler and VFX Forth to /usr/local/bin
# Install the shared libraries to /usr/lib
if [ -d Bin ]
then
  # not Mission
  sudo cp -p  Bin/VfxForth*_x64_lin.elf  /usr/local/bin/
  sudo cp -p  Bin/x64.elf  /usr/local/bin
  sudo cp -p  Bin/*64.so.*  /usr/lib/
  # set directory vars used later to set INI file
  VFXSRCDIR=`pwd`
  VFXROOTDIR=`pwd`
else
  if [ -d Sources/Images ]
  then
    # Mission
    sudo cp -p  Sources/Images/VfxForth*_x64_lin.elf  /usr/local/bin/
    sudo cp -p  Sources/Images/x64.elf  /usr/local/bin
    sudo cp -p  Sources/Images/*64.so.*  /usr/lib/
    # set directory vars used later to set INI file
    VFXSRCDIR=`pwd`/Sources
    VFXROOTDIR=`pwd`
  else
    echo Cannot find executable files
    exit 2
  fi
fi
# install vfxlin short cut to primary executable
pushd /usr/local/bin
if [ -e vfxlin ]; then
   sudo rm vfxlin
fi
ln -s VfxForth_x64_lin.elf vfxlin64
ln -s VfxForth_x64_lin.elf vfx64
popd

# make directory vars visible
export VFXSRCDIR
export VFXROOTDIR

# Create a default INI file if there isn't one
if [ ! -f  ${HOME}/.VfxForth.ini ]
then
  ./ChangeIni.Lin64.sh
fi

# Run VFX to finish the INI file set up
# Uses VFXSRCDIR and VFXROOTDIR variables
"${VFXBINFILE}" "cr .( type bye to exit ) cr"
