#! /bin/bash
# 20191018 Build all kernels at once
# first stage build

VFX_BUILDKIT_DIR=${VFX_BUILDKIT_DIR:-$HOME/buildkit.dev}

# build arguments
VFX_ARGS="1 constant Community?"
if [ "$VFX_BATCH_MODE" -eq "1" ]; then
    VFX_ARGS+=" 1 constant BatchMode"
fi

# save the INI file
cp ~/.VfxForth/VfxForth.ini ini.temp

# Build the desktop version
# TODO CI2020 stephen: why isn't that crosscompile in the buildkit?
if [ -d ../Images ]; then
  XCDIR=../Images
else
  if [ -d ../Bin ]; then
    XCDIR=../Bin
  else
    XCDIR=${HOME}/buildkit.dev/software/COMPILER
  fi
fi
echo Compiler in directory ${XCDIR}
$XCDIR/x64.elf $VFX_ARGS include x64lin1.ctl
mv -f VFXFORTH.img  vfxkern64.elf
chmod +x vfxkern64.elf
cp -a vfxkern64.elf  ../Images/VfxForthK_x64_lin.elf

# restore the INI file
mv ini.temp ~/.VfxForth/VfxForth.ini
