\ TestAsmx64.fth - Assembler test file

((
Copyright (c) 2006, 2009, 2017, 2018, 2020
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

decimal
\ debug1 on


\ ***************
\ Test code
\ ***************

optimised

[undefined] equ [if]
: equ constant  ;
[then]

$55 equ imm8
$55AA equ imm16
$12345678 equ imm32

variable varFooBar

code adc1
  adc	al, # imm8
  adc	ax, # imm16
  adc	eax, # imm32
  adc	rax, # imm32

  adc	cl, # imm8
  adc	byte 0 [rbx], # imm8
  adc	byte 0 [r10], # imm8

  adc	cx, # imm16
  adc	word 0 [rbx], # imm16
  adc	word 0 [r10], # imm16

  adc	ecx, # imm32
  adc	dword 0 [rbx], # imm32
  adc	dword 0 [r10], # imm32

  adc	rcx, # imm32
  adc	qword 0 [rbx], # imm32
  adc	qword 0 [r10], # imm32

  adc	cl, r12l
  adc	byte 0 [rbx], r12l
  adc	byte 0 [r10], r12l

  adc	cx, r10w
  adc	word 0 [rbx], r12w
  adc	word 0 [r10], r12w

  adc	ecx, r12d
  adc	dword 0 [rbx], r12d
  adc	dword 0 [r10], r12d

  adc	rcx, r12
  adc	qword 0 [rbx], r12
  adc	qword 0 [r10], r12

  adc	cl, r12l
  adc	r12l, 0 [rbx]
  adc	r12l, 0 [r10]

  adc	cx, r10w
  adc	cx, word 0 [rbx]
  adc	cx, word 0 [r10]

  adc	ecx, r12d
  adc	ecx, dword 0 [rbx]
  adc	ecx, dword 0 [r10]

  adc	rcx, r12
  adc	r12, 0 [rbx]
  adc	r12, 0 [r10]

  adc	r12l, 0 [rbx] [rsi]
  adc	r12l, imm8 [r10] [rsi]
  adc	cx, word 0 [rbx] [rsi]
  adc	cx, word imm32 [r10] [rsi]
  adc	ecx, r12d
  adc	ecx, dword 0 [rbx] [rsi]
  adc	ecx, dword imm8 [r10] [rsi]
  adc	r12, 0 [rbx] [rsi]
  adc	r12, imm8 [r10] [rsi]

  adc	r12l, 0 [rbx] [rsi]
  adc	r12l, imm8 [r10] [rsi]

  next,
end-code

code add1
  add	al, # imm8
  add	ax, # imm16
  add	eax, # imm32
  add	rax, # imm32

  add	cl, # imm8
  add	byte 0 [rbx], # imm8
  add	byte 0 [r10], # imm8
  add	cx, # imm16
  add	word 0 [rbx], # imm16
  add	word 0 [r10], # imm16
  add	ecx, # imm32
  add	dword 0 [rbx], # imm32
  add	dword 0 [r10], # imm32
  add	rcx, # imm32
  add	qword 0 [rbx], # imm32
  add	qword 0 [r10], # imm32

  add	cl, r12l
  add	r12l, 0 [rbx]
  add	r12l, 0 [r10]
  add	cx, r10w
  add	cx, word 0 [rbx]
  add	cx, word 0 [r10]
  add	ecx, r12d
  add	ecx, dword 0 [rbx]
  add	ecx, dword 0 [r10]
  add	rcx, r12
  add	r12, 0 [rbx]
  add	r12, 0 [r10]

  next,
end-code

code and1
  and	al, # imm8
  and	ax, # imm16
  and	eax, # imm32
  and	rax, # imm32

  and	cl, # imm8
  and	byte 0 [rbx], # imm8
  and	byte 0 [r10], # imm8
  and	cx, # imm16
  and	word 0 [rbx], # imm16
  and	word 0 [r10], # imm16
  and	ecx, # imm32
  and	dword 0 [rbx], # imm32
  and	dword 0 [r10], # imm32
  and	rcx, # imm32
  and	qword 0 [rbx], # imm32
  and	qword 0 [r10], # imm32

  and	cl, r12l
  and	r12l, 0 [rbx]
  and	r12l, 0 [r10]
  and	cx, r10w
  and	cx, word 0 [rbx]
  and	cx, word 0 [r10]
  and	ecx, r12d
  and	ecx, dword 0 [rbx]
  and	ecx, dword 0 [r10]
  and	rcx, r12
  and	r12, 0 [rbx]
  and	r12, 0 [r10]

  next,
end-code

code bsf1
  bsf	cx, r12w
  bsf   ecx, r12d
  bsf   rcx, r12
  bsf	r12w, 0 [rbx]
  bsf	r12d, 0 [r10]
  bsf   r12, 0 [r10] [rsi]
  bsf	cx, r10w
  bsf	cx, word 0 [rbx]
  bsf	cx, word 0 [r10]
  bsf	ecx, r12d
  bsf	ecx, dword 0 [rbx]
  bsf	ecx, dword 0 [r10]
  bsf	rcx, r12
  bsf	r12, 0 [rbx]
  bsf	r12, 0 [r10]

  next,
end-code

code bsr1
  bsr	cx, r12w
  bsr   ecx, r12d
  bsr   rcx, r12
  bsr	r12w, 0 [rbx]
  bsr	r12d, 0 [r10]
  bsr   r12, 0 [r10] [rsi]
  bsr	cx, r10w
  bsr	cx, word 0 [rbx]
  bsr	cx, word 0 [r10]
  bsr	ecx, r12d
  bsr	ecx, dword 0 [rbx]
  bsr	ecx, dword 0 [r10]
  bsr	rcx, r12
  bsr	r12, 0 [rbx]
  bsr	r12, 0 [r10]

  next,
end-code

code btc1
  btc  imm8 [rbx], cx
  btc  imm8 [r10], ecx
  btc  imm8 [r10], rcx
  btc  word 0 [rbx] [rsi], # imm8
  btc  dword 0 [r10] [rsi], # imm8
  btc  qword 0 [r10] [rsi], # imm8
  next,
end-code

code btx1
  btr  imm8 [rbx], cx
  btr  imm8 [r10], ecx
  btr  imm8 [r10], rcx
  btr  word 0 [rbx] [rsi], # imm8
  btr  dword 0 [r10] [rsi], # imm8
  btr  qword 0 [r10] [rsi], # imm8

  bts  imm8 [rbx], cx
  bts  qword 0 [r10] [rsi], # imm8

  next,
end-code

code calltest1
  ret
end-code

code call1
  call	' calltest1
\  call  l$2
  call  qword 0 [rbx]
  next,
end-code

code calltest2
l$2:
  ret
end-code

code conv1
  cbw
  cwde
  cdqe
  cwd
  cdq
  cqo
  next,
end-code

code flags1
  clc
  cld
  cli

  cmc

  clts

  stc
  std
  sti

  next,
end-code

code cmov1
  cmova  rax, ptr varFooBar
  cmova  eax, ptr varFooBar
  cmova  ax,  ptr varFooBar

  cmovae  r8, r10
  cmovae  r8d, r10d
  cmovae  r8w, r10w

  cmovb   rbx, 0 [r8]
  cmovb   ebx, 0 [r8]
  cmovb   bx,  0 [r8]

  next,
end-code

code cmp1
  cmp	al, # imm8
  cmp	ax, # imm16
  cmp	eax, # imm32
  cmp	rax, # imm32

  cmp	cl, # imm8
  cmp	byte 0 [rbx], # imm8
  cmp	byte 0 [r10], # imm8

  cmp	cx, # imm16
  cmp	word 0 [rbx], # imm16
  cmp	word 0 [r10], # imm16

  cmp	ecx, # imm32
  cmp	dword 0 [rbx], # imm32
  cmp	dword 0 [r10], # imm32

  cmp	rcx, # imm32
  cmp	qword 0 [rbx], # imm32
  cmp	qword 0 [r10], # imm32

  cmp	cl, r12l
  cmp	byte 0 [rbx], r12l
  cmp	byte 0 [r10], r12l

  cmp	cx, r10w
  cmp	word 0 [rbx], r12w
  cmp	word 0 [r10], r12w

  cmp	ecx, r12d
  cmp	dword 0 [rbx], r12d
  cmp	dword 0 [r10], r12d

  cmp	rcx, r12
  cmp	qword 0 [rbx], r12
  cmp	qword 0 [r10], r12

  cmp	cl, r12l
  cmp	r12l, 0 [rbx]
  cmp	r12l, 0 [r10]

  cmp	cx, r10w
  cmp	cx, word 0 [rbx]
  cmp	cx, word 0 [r10]

  cmp	ecx, r12d
  cmp	ecx, dword 0 [rbx]
  cmp	ecx, dword 0 [r10]

  cmp	rcx, r12
  cmp	r12, 0 [rbx]
  cmp	r12, 0 [r10]

  cmp	r12l, 0 [rbx] [rsi]
  cmp	r12l, imm8 [r10] [rsi]
  cmp	cx, word 0 [rbx] [rsi]
  cmp	cx, word imm32 [r10] [rsi]
  cmp	ecx, r12d
  cmp	ecx, dword 0 [rbx] [rsi]
  cmp	ecx, dword imm8 [r10] [rsi]
  cmp	r12, 0 [rbx] [rsi]
  cmp	r12, imm8 [r10] [rsi]

  cmp	r12l, 0 [rbx] [rsi]
  cmp	r12l, imm8 [r10] [rsi]

  next,
end-code

code cmpx1	\ --
  cmpxchg  0 [rbx], cl
  cmpxchg  [] varFooBar , dl
  cmpxchg  0 [rbx], cx
  cmpxchg  [] varFooBar , dx
  cmpxchg  0 [rbx], ecx
  cmpxchg  ptr varFooBar , edx
  cmpxchg  0 [rbx], rcx
  cmpxchg  ptr varFooBar , rdx
  next,
end-code

code dec/inc	\ --
  dec  sil
  dec  byte ptr varFooBar
  dec  ax
  dec  word ptr varFooBar
  dec  eax
  dec  dword ptr varFooBar
  dec  rax
  dec  qword ptr varFooBar
  inc  sil
  inc  byte ptr varFooBar
  inc  ax
  inc  word ptr varFooBar
  inc  eax
  inc  dword ptr varFooBar
  inc  rax
  inc  qword ptr varFooBar
  next,
end-code

code div1	\ --
  div  sil
  div  byte 8 [r9]
  div  r8w
  div  r8d
  div  r8

  idiv  sil
  idiv  byte 8 [r9]
  idiv  r8w
  idiv  r8d
  idiv  r8

  next,
end-code

code lea1	\ --
  lea	rbp, 8 [rbp]

  lea   rdx, 0 [rbx] [rcx*8]
  lea   rdx, $55 [rbx] [rcx*8]
  lea   rdx, $-55 [rbx] [rcx*8]
  lea   rdx, $11223344 [rbx] [rcx*8]

  lea	rdx, 0 [rcx*8]
  lea   rdx, $55 [rcx*8]
  lea   rdx, $-55 [rcx*8]
  lea   rdx, $11223344 [rcx*8]
  next,
end-code

code mul1
  imul  sil
  imul  byte 8 [r9]
  imul  word r8w
  imul  dword r8d
  imul  r8

  imul  r8w, cx
  imul  r8d, ecx
  imul  r8, rcx

  imul  r8w, cx, # imm8
  imul  r8d, ecx, # imm8
  imul  r8, rcx, # imm8

  imul  r8w, 8 [rsi],  # imm8
  imul  r8d, 8 [rsi], # imm8
  imul  r8, 8 [rsi], # imm8

  imul  r8w, cx, # imm16
  imul  r8d, ecx, # imm32
  imul  r8, rcx, # imm32

  mul   sil
  mul   byte 8 [r9]
  mul   word r8w
  mul   dword r8d
  mul   r8

  next,
end-code

code strings	\ --
  lodsb
  lodsw
  lodsd
  lodsq

  movsb
  movsw
  movsd
  movsq

  scasb
  scasw
  scasd
  scasq

  stosb
  stosw
  stosd
  stosq

  next,
end-code

variable vrob

code mov1	\ --
  mov  imm8 [rax], bl
  mov  imm8 [r8], bl
  mov  imm8 [r8], bx
  mov  imm8 [r8], ebx
  mov  imm8 [r8], rbx

  mov  bl, imm8 [r8]
  mov  bx, imm8 [r8]
  mov  ebx, imm8 [r8]
  mov  rbx, imm8 [r8]

  next,
end-code

code mov2	\ --
  mov  word 0 [rbx], fs
  mov  bx, fs
  mov  ebx, fs
  mov  rbx, fs
  mov  gs, bx
  mov  gs, rbx
  mov  gs, word imm8 [rbx]

  next,
end-code

code mov3	\ --
  mov  al, ptr64  imm32
  mov  ax, ptr64  imm32
  mov  eax, ptr64  imm32
  mov  rax, ptr64  imm32

  mov  ptr64 imm32 , al
  mov  ptr64 imm32 , ax
  mov  ptr64 imm32 , eax
  mov  ptr64 imm32 , rax

  mov  al, ptr  imm32
  mov  ax, ptr  imm32
  mov  eax, ptr  imm32
  mov  rax, ptr  imm32

  mov  ptr imm32 , al
  mov  ptr imm32 , ax
  mov  ptr imm32 , eax
  mov  ptr imm32 , rax

  next,
end-code

code mov4	\ --
  mov  bl, # imm8
  mov  bx, # imm16
  mov  ebx, # imm32
  mov  rbx, # imm32

  mov  byte 8 [rbx], # imm8
  mov  word 8 [rbx], # imm16
  mov  dword 8 [rbx], # imm32
  mov  qword 8 [rbx], # imm32

  next,
end-code
((
00000021 C6430855                  mov  byte  [rbx+8], 0x55
00000025 66C74308AA55              mov  word  [rbx+8], 0x55AA
0000002B C7430878563412            mov  dword  [rbx+8], 0x12345678
00000032 48C7430878563412          mov  qword  [rbx+8], 0x12345678
))
code mov5	\ --
\  mov  bl, ptr vrof
\  mov  bx, ptr vrof
\  mov  ebx, ptr vrof
\  mov  rbx, ptr vrof

  mov  bl, [] vrob
  mov  bx, [] vrob
  mov  ebx, [] vrob
  mov  rbx, [] vrob

  next,
end-code

variable vrof

code movxx1	\ --
  movsx  bx, cl
  movsx  bx, byte 0 [rdx]
  movsx  ebx, cl
  movsx  rbx, cl
  movsx  ebx, byte 0 [rdx]
  movsx  rbx, byte 0 [rdx]

  movsx  ebx, cx
  movsx  rbx, cx

  movzx  bx, cl
  movzx  bx, byte 0 [rdx]
  movzx  ebx, cl
  movzx  rbx, cl

  movzx  ebx, cx
  movzx  rbx, cx
  movzx  ebx, byte 0 [rdx]
  movzx  rbx, byte 0 [rdx]

  next,
end-code

code neg1	\ --
  neg   sil
  neg   byte 8 [r9]
  neg   r8w
  neg   r8d
  neg   r8

  next,
end-code

code not1	\ --
  not   sil
  not   byte 8 [r9]
  not   r8w
  not   r8d
  not   r8

  next,
end-code

code or1	\ --
  or	al, # imm8
  or	ax, # imm16
  or	eax, # imm32
  or	rax, # imm32

  or	cl, # imm8
  or	byte 0 [rbx], # imm8
  or	byte 0 [r10], # imm8
  or	cx, # imm16
  or	word 0 [rbx], # imm16
  or	word 0 [r10], # imm16
  or	ecx, # imm32
  or	dword 0 [rbx], # imm32
  or	dword 0 [r10], # imm32
  or	rcx, # imm32
  or	qword 0 [rbx], # imm32
  or	qword 0 [r10], # imm32

  or	cl, r12l
  or	r12l, 0 [rbx]
  or	r12l, 0 [r10]
  or	cx, r10w
  or	cx, word 0 [rbx]
  or	cx, word 0 [r10]
  or	ecx, r12d
  or	ecx, dword 0 [rbx]
  or	ecx, dword 0 [r10]
  or	rcx, r12
  or	r12, 0 [rbx]
  or	r12, 0 [r10]

  next,
end-code

code out1	\ --
  out # imm8 al
  out # imm8 ax
  out # imm8 eax
  out dx, al
  out dx, ax
  out dx, eax

  outsb
  outsw
  outsd

  next,
end-code

code pop/push1	\ --
  pop    ax
  pop    word 8 [r9]

  pop    rax
  pop    qword 8 [r9]
  pop    r9

  pop	cx
  pop	rcx

  pop	fs
  pop	gs

  push	ax
  push	word 8 [r9]
\  push	eax
\  push	dword 8 [r9]
  push	rax
  push	qword 8 [r9]

  push	cx
\  push	ecx
  push	rcx
  push  r9

\  push	byte # imm8
  push  word # imm16
\  push  dword # imm32
  push  qword # imm16

  push	fs
  push	gs

  next,
end-code

code ret1	\ --
  z, if,  ret  then,
  nz, if,   ret # imm16  then,

  ret
end-code

code shift1	\ --
  sal	sil, # 1
  sal   byte 0 [rbx], # 1
  sal   byte 0 [rbx] [rsi], # 1
  sal	sil, cl
  sal   byte 0 [rbx], cl
  sal   byte 0 [rbx] [rsi], cl
  sal	sil, # imm8
  sal   byte 0 [rbx], # imm8
  sal   byte 0 [rbx] [rsi], # imm8

  sal	si, # 1
  sal   word 0 [rbx], # 1
  sal   word 0 [rbx] [rsi], # 1
  sal	si, cl
  sal   word 0 [rbx], cl
  sal   word 0 [rbx] [rsi], cl
  sal	si, # imm8
  sal   word 0 [rbx], # imm8
  sal   word 0 [rbx] [rsi], # imm8

  sal	esi, # 1
  sal   dword 0 [rbx], # 1
  sal   dword 0 [rbx] [rsi], # 1
  sal	esi, cl
  sal   dword 0 [rbx], cl
  sal   dword 0 [rbx] [rsi], cl
  sal	esi, # imm8
  sal   dword 0 [rbx], # imm8
  sal   dword 0 [rbx] [rsi], # imm8

  sal	rsi, # 1
  sal   qword 0 [rbx], # 1
  sal   qword 0 [rbx] [rsi], # 1
  sal	rsi, cl
  sal   qword 0 [rbx], cl
  sal   qword 0 [rbx] [rsi], cl
  sal	rsi, # imm8
  sal   qword 0 [rbx], # imm8
  sal   qword 0 [rbx] [rsi], # imm8

  sar	sil, # 1
  sar   byte 0 [rbx], # 1
  sar   byte 0 [rbx] [rsi], # 1
  sar	sil, cl
  sar   byte 0 [rbx], cl
  sar   byte 0 [rbx] [rsi], cl
  sar	sil, # imm8
  sar   byte 0 [rbx], # imm8
  sar   byte 0 [rbx] [rsi], # imm8

  sar	si, # 1
  sar   word 0 [rbx], # 1
  sar   word 0 [rbx] [rsi], # 1
  sar	si, cl
  sar   word 0 [rbx], cl
  sar   word 0 [rbx] [rsi], cl
  sar	si, # imm8
  sar   word 0 [rbx], # imm8
  sar   word 0 [rbx] [rsi], # imm8

  sar	esi, # 1
  sar   dword 0 [rbx], # 1
  sar   dword 0 [rbx] [rsi], # 1
  sar	esi, cl
  sar   dword 0 [rbx], cl
  sar   dword 0 [rbx] [rsi], cl
  sar	esi, # imm8
  sar   dword 0 [rbx], # imm8
  sar   dword 0 [rbx] [rsi], # imm8

  sar	rsi, # 1
  sar   qword 0 [rbx], # 1
  sar   qword 0 [rbx] [rsi], # 1
  sar	rsi, cl
  sar   qword 0 [rbx], cl
  sar   qword 0 [rbx] [rsi], cl
  sar	rsi, # imm8
  sar   qword 0 [rbx], # imm8
  sar   qword 0 [rbx] [rsi], # imm8

  shr	sil, # 1
  shr   byte 0 [rbx], # 1
  shr   byte 0 [rbx] [rsi], # 1
  shr	sil, cl
  shr   byte 0 [rbx], cl
  shr   byte 0 [rbx] [rsi], cl
  shr	sil, # imm8
  shr   byte 0 [rbx], # imm8
  shr   byte 0 [rbx] [rsi], # imm8

  shr	si, # 1
  shr   word 0 [rbx], # 1
  shr   word 0 [rbx] [rsi], # 1
  shr	si, cl
  shr   word 0 [rbx], cl
  shr   word 0 [rbx] [rsi], cl
  shr	si, # imm8
  shr   word 0 [rbx], # imm8
  shr   word 0 [rbx] [rsi], # imm8

  shr	esi, # 1
  shr   dword 0 [rbx], # 1
  shr   dword 0 [rbx] [rsi], # 1
  shr	esi, cl
  shr   dword 0 [rbx], cl
  shr   dword 0 [rbx] [rsi], cl
  shr	esi, # imm8
  shr   dword 0 [rbx], # imm8
  shr   dword 0 [rbx] [rsi], # imm8

  shr	rsi, # 1
  shr   qword 0 [rbx], # 1
  shr   qword 0 [rbx] [rsi], # 1
  shr	rsi, cl
  shr   qword 0 [rbx], cl
  shr   qword 0 [rbx] [rsi], cl
  shr	rsi, # imm8
  shr   qword 0 [rbx], # imm8
  shr   qword 0 [rbx] [rsi], # imm8

  ret
end-code

code sbb1
  sbb	al, # imm8
  sbb	ax, # imm16
  sbb	eax, # imm32
  sbb	rax, # imm32

  sbb	cl, # imm8
  sbb	byte 0 [rbx], # imm8
  sbb	byte 0 [r10], # imm8

  sbb	cx, # imm16
  sbb	word 0 [rbx], # imm16
  sbb	word 0 [r10], # imm16

  sbb	ecx, # imm32
  sbb	dword 0 [rbx], # imm32
  sbb	dword 0 [r10], # imm32

  sbb	rcx, # imm32
  sbb	qword 0 [rbx], # imm32
  sbb	qword 0 [r10], # imm32

  sbb	cl, r12l
  sbb	byte 0 [rbx], r12l
  sbb	byte 0 [r10], r12l

  sbb	cx, r10w
  sbb	word 0 [rbx], r12w
  sbb	word 0 [r10], r12w

  sbb	ecx, r12d
  sbb	dword 0 [rbx], r12d
  sbb	dword 0 [r10], r12d

  sbb	rcx, r12
  sbb	qword 0 [rbx], r12
  sbb	qword 0 [r10], r12

  sbb	cl, r12l
  sbb	r12l, 0 [rbx]
  sbb	r12l, 0 [r10]

  sbb	cx, r10w
  sbb	cx, word 0 [rbx]
  sbb	cx, word 0 [r10]

  sbb	ecx, r12d
  sbb	ecx, dword 0 [rbx]
  sbb	ecx, dword 0 [r10]

  sbb	rcx, r12
  sbb	r12, 0 [rbx]
  sbb	r12, 0 [r10]

  sbb	r12l, 0 [rbx] [rsi]
  sbb	r12l, imm8 [r10] [rsi]
  sbb	cx, word 0 [rbx] [rsi]
  sbb	cx, word imm32 [r10] [rsi]
  sbb	ecx, r12d
  sbb	ecx, dword 0 [rbx] [rsi]
  sbb	ecx, dword imm8 [r10] [rsi]
  sbb	r12, 0 [rbx] [rsi]
  sbb	r12, imm8 [r10] [rsi]

  sbb	r12l, 0 [rbx] [rsi]
  sbb	r12l, imm8 [r10] [rsi]

  next,
end-code

code setcc1	\ --
  seto	cl
  seto  byte ptr varFooBar

  setno	cl
  setno byte ptr varFooBar

  seta	cl				\ setnbe
  seta  byte ptr varFooBar
  setae	cl
  setae	byte ptr varFooBar

  setbe	cl				\ setna
  setbe byte ptr varFooBar

  setc	cl				\ setb setnae
  setc  byte ptr varFooBar

  sete	cl
  sete  byte ptr varFooBar

  setg	cl				\ setnle
  setg  byte ptr varFooBar

  setge	cl
  setge byte ptr varFooBar

  next,
end-code

code shiftd1	\ --
  shld		word 0 [rbx], cx, # imm8
  shld		word 0 [rbx], cx, cl
  shld		dword 0 [rbx], ecx, # imm8
  shld		qword 0 [rbx], rcx, # imm8
  shld		dword 0 [rbx], ecx, cl
  shld		qword 0 [rbx], rcx, cl

  shrd		word 0 [rbx], cx, # imm8
  shrd		word 0 [rbx], cx, cl
  shrd		dword 0 [rbx], ecx, # imm8
  shrd		qword 0 [rbx], rcx, # imm8
  shrd		dword 0 [rbx], ecx, cl
  shrd		qword 0 [rbx], rcx, cl

  next,
end-code

code sub1	\ --
  sub	al, # imm8
  sub	ax, # imm16
  sub	eax, # imm32
  sub	rax, # imm32

  sub	cl, # imm8
  sub	byte 0 [rbx], # imm8
  sub	byte 0 [r10], # imm8
  sub	cx, # imm16
  sub	word 0 [rbx], # imm16
  sub	word 0 [r10], # imm16
  sub	ecx, # imm32
  sub	dword 0 [rbx], # imm32
  sub	dword 0 [r10], # imm32
  sub	rcx, # imm32
  sub	qword 0 [rbx], # imm32
  sub	qword 0 [r10], # imm32
  sub   qword ptr varFoobar , # imm32

  sub	cl, r12l
  sub	r12l, 0 [rbx]
  sub	r12l, 0 [r10]
  sub	cx, r10w
  sub	cx, word 0 [rbx]
  sub	cx, word 0 [r10]
  sub	ecx, r12d
  sub	ecx, dword 0 [rbx]
  sub	ecx, dword 0 [r10]
  sub	rcx, r12
  sub	r12, 0 [rbx]
  sub	r12, 0 [r10]
  sub   r12, ptr varFooBar

  next,
end-code

code test1	\ --
  test		al, # imm8
  test		ax, # imm16
  test		eax, # imm32
  test		rax, # imm32

  test		cl, # imm8
  test		byte 0 [rbx], # imm8
  test		byte 0 [r10], # imm8
  test		byte ptr varFooBar , # imm8
  test		cx, # imm16
  test		word 0 [rbx], # imm16
  test		word 0 [r10], # imm16
  test		word ptr varFooBar , # imm16
  test		ecx, # imm32
  test		dword 0 [rbx], # imm32
  test		dword 0 [r10], # imm32
  test		dword ptr varFooBar , # imm32
  test		rcx, # imm32
  test		qword 0 [rbx], # imm32
  test		qword 0 [r10], # imm32
  test		qword ptr varFooBar , # imm32

  test		r12l, cl
  test		0 [rbx], cl
  test		0 [r10], cl
  test		byte ptr varFooBar , cl
  test		r10w, cx
  test		word 0 [rbx], cx
  test		word 0 [r10], cx
  test		ptr varFooBar , cx
  test		r12d, ecx
  test		dword 0 [rbx], ecx
  test		dword 0 [r10], ecx
  test		dword ptr varFooBar , ecx
  test		r12, rcx
  test		qword 0 [rbx], rcx
  test		qword 0 [r10], rcx
  test		qword ptr varFooBar , rcx

  next,
end-code

code misc1	\ --
  clflush	cl
  clflush	byte 0 [rbx]
  clflush	byte 0 [r10]
  clflush	byte ptr varFooBar

  lfence
  mfence

  lzcnt		cx, word 0 [rbx]
  lzcnt		ecx, dword 0 [rbx]
  lzcnt		rcx, qword 0 [rbx]

  lzcnt		r12w, word 0 [rbx] [rsi]
  lzcnt		r12d, dword 0 [rbx] [rbp]
  lzcnt		r12, qword ptr varFooBar

  tzcnt		cx, word 0 [rbx]
  tzcnt		ecx, dword 0 [rbx]
  tzcnt		rcx, qword 0 [rbx]

  popcnt	cx, word 0 [rbx]
  popcnt	ecx, dword 0 [rbx]
  popcnt	rcx, qword 0 [rbx]

  rep

  movbe		r12w, word 0 [rbx] [rsi]
  movbe		r12d, dword 0 [rbx] [rbp]
  movbe		r12, qword ptr varFooBar
  movbe		word 0 [rbx] [rsi], r12w
  movbe		dword 0 [rbx] [rbp], r12d
  movbe		qword ptr varFooBar , r12

  syscall
  sysenter

  next,
end-code

: dup dup ;
: over over  ;
: swap swap  ;
: rot rot  ;
: -rot -rot  ;
: drop drop  ;
: 2drop drop drop  ;
: 3drop drop drop drop  ;
: 4drop drop drop drop drop  ;
: bounds over + swap  ;
: dig1  dup 9 >  ;
: dig2  dup 9 > if  7 +  endif  ;
: dig3  9 over < if  7 +  endif  ;
: min
  2dup >
  if  nip exit  then
  drop  ;
: min2
  2dup >
  if  swap  then
  drop  ;
: ?dup ?dup ;
: tq1 ?dup if drop endif ;
: tq2 ?dup 0= if  7  endif  ;
: - - ;
: 4-a 4- ;
: 4-b 4 - ;
: n- 10 - ;

: t1 2dup @ ;
: t2 2dup 2@ ;
: t3 rot 2!  ;
: t4a  +!  ;
: t4b 4 swap +!  ;
: t4c 6 swap +!  ;
: t4d dup @ rot + swap !  ;     \ high level version of +!
: t4 incr  ;
: t5 decr  ;
: t6 2dup !  ;
: t7  >r  r@ drop  r> drop  ;

code (do)	\ limit index
  pop		rdx			\ rdx = return address
  mov		rcx, 0 [rdx]		\ exit address
  lea		rdx, 8 [rdx]		\ step over it
  push		rcx			\ rcx = exit address
  push		r15			\ r15 = old index - limit - msb
  push		r14			\ r14 = old index

  mov		r15, rbx		\ rbx = index, r15 = index
  sub           r15, 0 [rbp]		\ r15 = index - limit
  btc		r15, # 63		\ r15 = index - limit - msb ; BTC=complement
  mov		r14, rbx		\ r14 = index

  mov		rbx, 8 [rbp]		\ restore TOS
  lea		rbp, 8 [rbp]		\ step data stack

  jmp		edx
  next,
end-code

code (?do)	\ limit index --
  cmp		rbx, 0 [rbp]		\ index = limit
  nz, if,
    pop		rdx			\ rdx = return address
    mov		rcx, 0 [rdx]		\ exit address
    lea		rdx, 8 [rdx]		\ step over it
    push	rcx			\ rcx = exit address
    push	r15			\ r15 = old index - limit - msb
    push	r14			\ r14 = old index

    mov		r15, rbx		\ rbx = index, r15 = index
    sub         r15, 0 [rbp]		\ r15 = index - limit
    btc		r15, # 63		\ r15 = index - limit - msb ; BTC=complement
    mov		r14, rbx		\ r14 = index

    mov		rbx, 8 [rbp]		\ restore TOS
    lea		rbp, 8 [rbp]		\ step data stack

    jmp		rdx
  then,
  pop		rdx			\ rdx = return address
  mov		rcx, 0 [rdx]		\ exit address
  mov		rbx, 8 [rbp]		\ restore TOS
  lea		rbp, 8 [rbp]		\ step data stack
  jmp		rcx
  next,
end-code

: t8 5 0 do  i drop  loop  ;
: t9 6 0 ?do  i drop  5 +loop  ;
: t10  rot drop  ;
: t11  swap 1 + nip  ;
: t12  2swap  ;
: t13  #-256 + ;

#200 user t14user
: t14  t14user @ 5 + ;

: t15  swap u2/ u2/ u2/  ;

variable t16var
create t16cr  0 , 0 , 0 ,
: t16
  $55 t16var c!
  $AA t16cr c!
  $AA t16cr 8 + c!
;

: t17           \ shuffle test
  swap 8 *  ;

: t18
  xor
[o/f]
  swap xor
[o/f]
  2dup xor
[o/f]
  2dup swap xor
;

: t19           \ literal tests
  $12345678 dup 1- +
;

0 constant ff
: t20   2drop ff ;

: t21   rot dup  ;


: COMPARE       \ c-addr1 u1 c-addr2 u2  --  n ; compare strings
  2swap                                                 \ a2 l2 a1 l1 --
  rot                                                   \ a2 a1 l1 l2 --
  2dup - >r                                             \ a2 a1 l1 l2 --
  min 0                                                 \ a2 a1  l1/l2 0
  ?do
    swap 1+  swap 1+                                    \ step to next address
    over 1- c@  over 1- c@ <>                           \ a2 a1 a2<>a1 --
    ?leave                                              \ until different
  loop                                                  \ or until done
  swap 1- c@  swap 1- c@  -                             \ last two chars
  ?dup if                                               \ see if same
    0<                                                  \ not same, return indicator
    if  +1  else  -1  then
    r> drop
  else
    r> dup if                                           \ strings =, see if same length
      0<                                                \ not, return indicator
      if  -1  else  +1  then
    then
  then
;

: testpick1
  over 3 pick  ;

: testpick2
  dup 1+
  3 pick
  3 pick
;

create tc1

: tc2 tc1  ;


\ =========
\ SSE tests
\ =========

code addx1
  addpd     xmm1, xmm2
  addpd     xmm14, xmm15
  addpd     xmm8, 0 [rbx]
  addpd     xmm1, imm8 [rcx]
  addpd     xmm1, imm32 [r8]

  addps     xmm1, xmm2
  addps     xmm14, xmm15
  addps     xmm8, 0 [rbx]
  addps     xmm1, imm8 [rcx]
  addps     xmm1, imm32 [r8]

  addsd     xmm1, xmm2
  addsd     xmm14, xmm15
  addsd     xmm8, 0 [rbx]
  addsd     xmm1, imm8 [rcx]
  addsd     xmm1, imm32 [r8]

  addss     xmm1, xmm2
  addss     xmm14, xmm15
  addss     xmm8, 0 [rbx]
  addss     xmm1, imm8 [rcx]
  addss     xmm1, imm32 [r8]

  next,
end-code

code andx1
  andpd     xmm1, xmm2
  andps     xmm8, xmm9

  andnpd    xmm1, xmm2
  andnps    xmm8, xmm9


  next,
end-code

code cmpxm1
  CMPEQPD 	xmm1, xmm2
  CMPLTPD   	xmm8, 0 [rbx]
  CMPLEPD   	xmm1, imm8 [r8]
  CMPUNORDPD	xmm1, imm32 [r12]
  CMPNEQPD  	xmm1, imm8 [rsi] [rdx]
  CMPNLTPD  	xmm1, xmm2
  CMPNLEPD  	xmm1, xmm2
  CMPORDPD  	xmm1, xmm2

  CMPEQPS       xmm1, xmm2
  CMPLTPS       xmm8, 0 [rbx]
  CMPLEPS       xmm1, imm8 [r8]
  CMPUNORDPS    xmm1, imm32 [r12]
  CMPNEQPS      xmm1, imm8 [rsi] [rdx]
  CMPNLTPS      xmm1, xmm2
  CMPNLEPS      xmm1, xmm2
  CMPORDPS      xmm1, xmm2

  CMPEQSD       xmm1, xmm2
  CMPLTSD       xmm8, 0 [rbx]
  CMPLESD       xmm1, imm8 [r8]
  CMPUNORDSD    xmm1, imm32 [r12]
  CMPNEQSD      xmm1, imm8 [rsi] [rdx]
  CMPNLTSD      xmm1, xmm2
  CMPNLESD      xmm1, xmm2
  CMPORDSD      xmm1, xmm2

  CMPEQSS       xmm1, xmm2
  CMPLTSS       xmm8, 0 [rbx]
  CMPLESS       xmm1, imm8 [r8]
  CMPUNORDSS    xmm1, imm32 [r12]
  CMPNEQSS      xmm1, imm8 [rsi] [rdx]
  CMPNLTSS      xmm1, xmm2
  CMPNLESS      xmm1, xmm2
  CMPORDSS      xmm1, xmm2

  next,
end-code

code comx1
  COMISD	xmm1, xmm2
  COMISS	xmm8, xmm9

  next,
end-code

create buff1  16 allot

code cvtx1
  CVTDQ2PD	xmm1, xmm10
  CVTDQ2PS      xmm1, xmm10
  CVTPD2DQ      xmm1, xmm10
  CVTPD2PS      xmm1, xmm10
  CVTPS2DQ      xmm1, xmm10
  CVTPS2PD      xmm1, xmm10
  CVTSD2SI 	ebx, dword $55 [rsi]
  CVTSD2SI 	r8, qword 0 [rbx]
  CVTSD2SS 	xmm1, xmm2
  CVTSI2SD 	xmm1, ebx
  CVTSI2SD 	xmm1, rbx
  CVTSI2SD 	xmm1, dword imm8 [rdi]
  CVTSI2SD 	xmm1, qword [] buff1
  CVTSI2SS 	xmm1, dword [] buff1
  CVTSS2SD 	xmm1, qword imm8 [rdi]
  CVTSS2SI 	r10, imm8 [rdi]
  CVTTPD2PQ	xmm1, xmm2
  CVTTPS2DQ	xmm1, xmm2
  CVTTSD2SI	rbx, xmm3
  CVTTSS2SI	ebx, xmm11

  next,
end-code

code divx1	\ --
  divpd		xmm1, xmm2
  divpd		xmm1, imm32 [r10]
  divps 	xmm1, xmm2
  divps		xmm1, imm32 [r10]
  divsd		xmm1, xmm2
  divsd		xmm1, imm32 [r10]
  divss		xmm1, xmm2
  divss		xmm1, imm32 [r10]
  next,
end-code

code memszx1	\ --
  fxsave	dword imm8 [rbp] [rsi]
  fxsave64	qword imm8 [rbx]
  ldmxcsr	dword [] varFooBar
  stmxcsr	qword 0 [r13]
  next,
end-code

code maxminx1	\ --
  maxpd		xmm1, xmm2
  maxpd		xmm1, 0 [r14]
  maxpd		xmm1, imm8 [rbx] [rdx]
  maxpd		xmm1, [] varFooBar

  maxps		xmm1, xmm2
  maxsd		xmm1, xmm2
  maxss		xmm1, xmm2

  minpd		xmm1, xmm2
  minps		xmm1, xmm2
  minsd		xmm1, xmm2
  minss		xmm1, xmm2
  next,
end-code

code movxm1
  MASKMOVDQU	xmm1, xmm2

  movapd	xmm1, xmm2
  movapd	xmm1, 0 [r14]
  movapd	xmm1, imm8 [rbx] [rdi]
  movapd	xmm1, [] varFooBar
  movapd	xmm2, xmm1
  movapd	0 [r14], xmm1
  movapd	imm8 [rbx] [rdi], xmm1
  movapd	[] varFooBar , xmm1

  movaps	xmm1, xmm2
  movaps	xmm1, 0 [r14]
  movaps	imm8 [rbx] [rdi], xmm1

  movd		xmm1, 0 [rbx]
  movd		0 [rcx], xmm2

  movq		xmm1, xmm2
  movq		xmm1, qword imm32 [rsi] [rdi]
  movq		xmm2, qword imm8 [r14]

  movdqa	xmm1, 0 [r8]
  movdqa	imm8 [r9], xmm2
  movdqu	xmm1, 0 [r8]
  movdqu	imm8 [r9], xmm2

  next,
end-code

code movxm2	\ --
  MOVHLPS		xmm1, xmm2
  MOVHLPS		xmm1, xmm9
  movhpd		xmm3, imm8 [rsi] [rdi]
  movhpd		imm8 [rsi] [rdi], xmm9
  movhps		xmm3, imm8 [rsi] [rdi]
  movhps		imm8 [rsi] [rdi], xmm9
  movlhps		xmm9, xmm15
  movlpd		xmm3, imm8 [rsi] [rdi]
  movlpd		imm8 [rsi] [rdi], xmm9
  movlps		xmm3, imm8 [rsi] [rdi]
  movlps		imm8 [rsi] [rdi], xmm9

  movmskpd		rbx, xmm9
  movmskps		ecx, xmm10
  movntdq		0 [rbx], xmm5
  movntpd		imm8 [r8] [r14], xmm5
  movntps		imm8 [r8] [r14], xmm5

  movsd
  movsd			xmm1, xmm3
  movsd			xmm1, imm8 [r8] [r14]
  movsd			imm8 [r8] [r14], xmm5
  movss			xmm1, xmm3
  movss			xmm1, imm8 [r8] [r14]
  movss			imm8 [r8] [r14], xmm5
  movupd		xmm1, xmm3
  movupd		xmm1, imm8 [r8] [r14]
  movupd		imm8 [r8] [r14], xmm5
  movups		xmm1, xmm3
  movups		xmm1, imm8 [r8] [r14]
  movups		imm8 [r8] [r14], xmm5

  next,
end-code

code mulx1	\ --
  mulpd		xmm10, 0 [rbx]
  mulpd		xmm10, imm8 [rsi] [rbx]
  mulpd		xmm10, imm32 [r12] [rdi]

  mulps		xmm10, 0 [rbx]
  mulps		xmm10, imm8 [rsi] [rbx]
  mulps		xmm10, imm32 [r12] [rdi]

  mulsd		xmm10, 0 [rbx]
  mulsd		xmm10, imm8 [rsi] [rbx]
  mulsd		xmm10, imm32 [r12] [rdi]

  mulss		xmm10, 0 [rbx]
  mulss		xmm10, imm8 [rsi] [rbx]
  mulss		xmm10, imm32 [r12] [rdi]

  next,
end-code

code orx1	\ --
  orpd		xmm2, xmm3
  orpd		xmm10, 0 [rbx]
  orpd		xmm10, imm8 [rsi] [rbx]
  orpd		xmm10, imm32 [r12] [rdi]

  orpd		xmm2, xmm3
  orpd		xmm10, 0 [rbx]
  orpd		xmm10, imm8 [rsi] [rbx]
  orpd		xmm10, imm32 [r12] [rdi]

  next,
end-code

code packx1	\ --
  PACKSSWB	xmm1, xmm3
  PACKSSDW	xmm1, 0 [r14]
  PACKUSWB	xmm1, imm8 [rsi] [r14]
  PADDB		xmm1, imm32 [rdi] [r14]
  PADDW		xmm1, xmm3
  PADDD		xmm1, xmm3
  PADDQ		xmm1, xmm3
  PADDUSB	xmm1, xmm3
  PADDUSW	xmm1, xmm3
  PAND		xmm1, xmm3
  PANDN		xmm1, xmm3
  PAVGB		xmm1, xmm3
  PAVGW		xmm1, xmm3
  PCMPEQB	xmm1, xmm3
  PCMPEQW	xmm1, xmm3
  PCMPEQD	xmm1, xmm3
  PCMPGTB	xmm1, xmm3
  PCMPGTW	xmm1, xmm3
  PCMPGTD	xmm1, xmm3
  PINSRW	xmm1, ebx, # $77
  PINSRW	xmm1, imm8 [rbx], # $77
  PINSRW	xmm1, imm32 [rsi] [rdi], # $77
  PMADDWD	xmm1, xmm3
  PMAXSW	xmm1, xmm3
  PMAXUB	xmm1, xmm3
  PMINSW	xmm1, xmm3
  PMINUB	xmm1, xmm3
  PMULHUW	xmm1, xmm3
  PMULHW	xmm1, xmm3
  PMULLW	xmm1, xmm3
  PMULUDQ	xmm1, xmm3
  POR		xmm1, xmm3
  PSADBWW	xmm1, xmm3
  PSHUFD	xmm1, xmm3, # imm8
  PSHUFHW	xmm1, 0 [rbx], # imm8
  PSHUFLW	xmm1, imm8 [r14], # imm8
  PSLLDQ	xmm1, # imm8
  PSLLW		xmm1, xmm3
  PSLLD		xmm1, # imm8
  PSLLQ		xmm1, xmm3
  PSRAW		xmm1, # imm8
  PSRAD		xmm1, xmm3
  PSRLDQ	xmm1, # imm8
  PSRLW		xmm1, xmm3
  PSRLW		xmm1, # imm8
  PSRLD		xmm1, 0 [r14]
  PSRLD		xmm1, # imm8
  PSRLQ		xmm1, imm8 [rsi] [rdi]
  PSRLQ		xmm1, # imm8
  PSUBB		xmm1, xmm3
  PSUBW		xmm1, xmm3
  PSUBD		xmm1, xmm3
  PSUBQ		xmm1, xmm3
  PSUBSB	xmm1, xmm3
  PSUBSW	xmm1, xmm3
  PSUBUSB	xmm1, xmm3
  PSUBUSW	xmm1, xmm3
  PUNPCKHBW	xmm1, xmm3
  PUNPCKHWD	xmm1, xmm3
  PUNPCKHDQ	xmm1, xmm3
  PUNPCKHQDQ	xmm1, xmm3
  PUNPCKLBW	xmm1, xmm3
  PUNPCKLWD	xmm1, xmm3
  PUNPCKLDQ	xmm1, xmm3
  PUNPCKLQDQ	xmm1, xmm3
  PXOR		xmm1, xmm3

  next,
end-code

code ropsx1	\ --
  RCPPS		xmm1, xmm2
  RCPPS		xmm1, imm8 [rsi] [r14]
  RCPSS		xmm1, xmm3
  RSQRTPS	xmm1, xmm2
  RSQRTSS	xmm1, xmm3

  next,
end-code

code sopsx1	\ --
  SHUFPD	xmm1, xmm2, # $77
  SHUFPS	xmm1, imm8 [rsi], # $77
  SQRTPD	xmm1, xmm3
  SQRTPS	xmm1, 0 [rbx]
  SQRTSD	xmm14, imm8 [rsi] [rdi]
  SQRTSS	xmm12, [] varFooBar
  STMXCSR	0 [rbx]
  SUBPD		xmm1, xmm3
  SUBPS		xmm1, xmm3
  SUBSD		xmm1, xmm3
  SUBSS		xmm1, xmm3

  next,
end-code

code uopsx1	\ --
  UCOMISD	xmm1, xmm10
  UCOMISS	xmm1, xmm10
  UNPCKHPD	xmm1, xmm10
  UNPCKHPS	xmm1, xmm10
  UNPCKLPD	xmm1, xmm10
  UNPCKLPS	xmm1, xmm10

  next,
end-code

code xopsx1	\ --
  XORPD		xmm1, xmm10
  XORPS		xmm1, xmm10

  next,
end-code


\ =======
\ Tidy up
\ =======

decimal


\ ======
\ *> ###
\ ======

