\ VfxSupp64.fth - support shared library access

((
Copyright (c) 1999-2004, 2006, 2008, 2009, 2018, 2020
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
net: mpe@mpeforth.com
     tech-support@mpeforth.com
web: www.mpeforth.com

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441


To do
=====

Change history
==============
20200610 SFP008 Linux 64 bit conversion.
20180404 SFP007 VFX 5.0 changes.
20090129 SFP006 Updated for NXCALL
20080205 VRW005 Linux overhaul/rewrite.
20061115 SFP004 Moved initialisation to SysPatch.fth.
20040607 SFP003 Added version number call initialisation
20030917 SFP002 Changed DLL startup detection
20020409 SFP001 Extended conversion string size in WinInteger?
))

decimal

also system definitions
[-short-branches
: isWinInteger?	{ caddr len | zstr[ #256 ] n[ cell ] -- d|n|X 2|1|0 }
  caddr len #255 umin isInteger?
  dup 0= if
    suppcall @ if
      caddr len #255 umin zstr[ zplace
      zstr[ n[ suppcall @ nxcall2 if
        drop n[ @ 1
      then
    then
  then
;
assign isWinInteger? to-do isNumber?
short-branches]
previous definitions

also system
: #OsConstants	\ -- u
  NumCall @ if
    NumCall @ nxcall0
  else
    0
  endif
;
previous


\ =============================
\ VfxSupp extension to SIMILARS
\ =============================

-short-branches
also system
: supsim	{ z$addr | notfound index res[ 256 ] -- }
  suppcall @ if
    res[ 256 erase
    0 -> index
    true -> notfound
    begin
      index -1 <> halt? 0= and
    while
      z$addr index res[ simcall @ nxcall3
      dup -1 <> if
        1+  notfound if
          cr cr ." Words in VFX support library:" cr
	  false -> notfound
        endif
        res[ ASCIIz>$ .tabword
      endif
      -> index
    repeat
  endif
;
previous
+short-branches

: dosupsim	\ --
  {: | temp[ 256 ] -- :}
  here count temp[ zplace  temp[ supsim
;
assign dosupsim to-do similars-extension


