[undefined] BatchMode [if] 0 constant BatchMode [then]

CROSS-COMPILE                           \ turn compiler on
only forth definitions                  \ set initial search order
no-log                                  \ no log file
align-xword				\ 64 bit alignment
+xrefs

BatchMode [if]                          \ force no interaction in BatchMode
    interactive-run off(m)
[else]
    interactive
[then]


\ ============================================================================
\       Calc memory offsets / section starts etc
\ ============================================================================

$0040:0000 equ PE-LOADBASE		\ normal i32 Linux load address
$007F:FFFF equ PE-CODELASTADDR           \ last byte of Code space (0 based)
$0000:0000 equ PE-CODERVA                \ Code RVA

PE-LOADBASE PE-CODERVA + equ SECTION-START
SECTION-START PE-CODELASTADDR + equ UNUSED-TOP

SECTION-START UNUSED-TOP cdata section VfxForth
  single-section-only
  VFX-headers


TRUE    equ     Target_x64_Linux
TRUE 	equ 	Host_Linux
TRUE 	equ 	CPU_x64

$4000 equ User-size		\ size of each task user area and exception stack
  $800 equ /ExceptStack		\ size of exception stack at top
  $800 equ /SysPad		\ size of SYSPAD below exception stack
  $400 dup equ /Pad equ PadSize	\ size of PAD buffer
$0800 equ Tib-len		\ terminal i/p buffer length
$1000 equ FS-size		\ size of float stack
$1:0000 equ SP-size		\ size of data stack
$2:0000 equ RP-size		\ size of return stack

include Common/VfxForth.ctl

\ ============================================================================
\       Set up sizes in ELF header
\       This might possible be better in another file, but it needs to be
\       performed at this stage of the compile.
\ ============================================================================


here  $FFF +  $-1000 and  org
cr here .dword
here  ehdr - equ filesize	\ total file size
filesize p_fileszref1 !

FINIS

