// mpegetosfna.c - using GetOpenFileName and friends from a DLL

#include <windows.h>
#include <stdio.h>
#include <commdlg.h>
#include <commctrl.h>
#include <Objbase.h>

//
// Functions
//
int WINAPI WinMain(
  HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow
);
BOOL pAskFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner,
  DWORD xtype, DWORD * pErrVal
);
BOOL AskOpenFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner
);
BOOL AskSaveFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner
);
BOOL pAskFile( char * zcap, char * zdir, char * pBuffer, DWORD xtype );
BOOL AskOpenFile( char * zcap, char * zdir, char * pBuffer );
BOOL AskSaveFile( char * zcap, char * zdir, char * pBuffer );

BOOL pAskFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner,
  DWORD xtype, DWORD * pErrVal
);
BOOL AskOpenFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner
);
BOOL AskSaveFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner
);

void make_szByte( char * src);
void dumpline( char * line );
void dump( void * start, int len );

// 
// Gobal Variables and declarations.
// 
OPENFILENAME ofn ;
DWORD AFNerrval;

// a another memory buffer to contain the file name
char szFile[256] ;
char *destbuff;					// build output here


//
// DLLmain - DLL startup code
//

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:
      /* Code path executed when DLL is loaded into a process's address space. */
        AFNerrval = 0;
        szFile[0]=0;
//	InitCommonControls();
//	MessageBox( NULL, "DLL initialised", "MPE", MB_OK );
      break;

    case DLL_THREAD_ATTACH:
      /* Code path executed when a new thread is created within the process. */
      break;

    case DLL_THREAD_DETACH:
      /* Code path executed when a thread within the process has exited *cleanly*. */
      break;

    case DLL_PROCESS_DETACH:
      /* Code path executed when DLL is unloaded from a process's address space. */
      break;
  }

  return TRUE;
}


//
// mpe_testOFN() - the test function
//

__declspec(dllexport) void mpe_testOFN()
{
	char szInit[MAX_PATH];
	char szOp[MAX_PATH];
	char szDir[MAX_PATH];
	char pBuffer[MAX_PATH];
	
	CoInitializeEx( NULL, COINIT_MULTITHREADED );
	
	InitCommonControls();

	MessageBox( NULL, " hello", "sailor", MB_OK );
	
	szInit[0]=0;
	szOp[0]=0;
	szDir[0]=0;
	
        pAskFileName( szInit, szOp, szDir, "MPE open file", NULL, 0, &AFNerrval );
//        AskOpenFile( "MPE open file", szDir, pBuffer );

	
	// Now simply display the file name 
	MessageBox( NULL, szOp , "File Name" , MB_OK);
}


//
// ---- file name tools ----
//

BOOL pAskFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner, DWORD xtype, DWORD * pErrVal
){
// return true for good selection
  OPENFILENAME ofn;
  char cDirBuff[MAX_PATH];			// current directory
  BOOL res;					// result type
  
  *pErrVal = 0 ;
  ZeroMemory( &ofn , sizeof( ofn));
  ofn.lStructSize = sizeof ( ofn );
  ofn.hwndOwner = hwndOwner  ;
  ofn.lpstrFilter = "All\0*.*\0Text\0*.TXT\0";
  ofn.nFilterIndex =1;
  ofn.lpstrFile = szInit ;			// initial file, returned path+file
  ofn.lpstrFile[0] = '\0';
  ofn.nMaxFile = MAX_PATH ;
  ofn.lpstrFileTitle = szOp ;			// returns file w/o path
  ofn.nMaxFileTitle = MAX_PATH ;
  ofn.lpstrInitialDir = szDir ;			// initial directory, can be NULL
  ofn.lpstrTitle = szCaption ;			// dialog caption, can be NULL
  
  GetCurrentDirectory( MAX_PATH, cDirBuff );
  if( xtype ){
     ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
     res = GetSaveFileName( &ofn );
  }else{
     ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
     res = GetOpenFileName( &ofn );
  }

  if( res ){
    GetCurrentDirectory( MAX_PATH, szDir );
  }else{
    *pErrVal = CommDlgExtendedError();
  }
  SetCurrentDirectory( cDirBuff );
  
  return res;
}

__declspec(dllexport) BOOL mpe_pAskFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner,
  DWORD xtype, DWORD * pErrVal
)
{
  BOOL b;
  b=pAskFileName( szInit, szOp, szDir, szCaption, hwndOwner, xtype, pErrVal );
  return b;  
}

BOOL AskOpenFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner
){
// *G Given the initial filename to show, where the selected file name goes, 
// ** the initial directory to use, the caption, and the handle of the 
// ** owning window/dialog, *\fo{ASKOPENFILENAME} will run the Windows open file 
// ** dialog. All strings are zero terminated, and the buffers are assumed 
// ** to be at least MAX_PATH in size. If the caption is 0, the default 
// ** caption will be used. Ior is true if a file was selected, and in this 
// ** case the directory information will be updated. 
  BOOL b;
  b=pAskFileName( szInit, szOp, szDir, szCaption, hwndOwner, 0, &AFNerrval );
  return b;
}

BOOL AskSaveFileName(
  char * szInit, char * szOp, char * szDir, char * szCaption, HWND hwndOwner
){
// *G As *\fo{ASKOPENFILENAME}, but the Windows save file dialog is used. 
  BOOL b;
  b=pAskFileName( szInit, szOp, szDir, szCaption, hwndOwner, 0, &AFNerrval );
  return b;
}

BOOL pAskFile( char * zcap, char * zdir, char * pBuffer, DWORD xtype )
// *G Run a file dialog with zcap as the caption (may be 0),
// ** zdir as a zero terminated string holding the default directory,
// ** pBuffer receiving the fully qualified path name selected,
// ** and xt being that of *\fo{GETSAVEFILENAME} or *\fo{GETOPENFILENAME}.
// ** Ior is returned 0 if a good selection was made. The output
// ** pBuffer is only updated if a good selection is made.
{
  char szIpText[MAX_PATH];
  char szOpText[MAX_PATH];
  BOOL b;
  const char szAll[]="*.*";
  
  strcpy( szIpText, szAll );
  memset( szOpText, 0, MAX_PATH );

  b = pAskFileName( szIpText, szOpText, zdir, pBuffer, zcap, 0, &AFNerrval );

  if( b )
    strcpy( pBuffer, szIpText );
  
  return b;
}

BOOL AskOpenFile( char * zcap, char * zdir, char * pBuffer )
// *G Run the file open dialog with zcap as the caption (may be 0),
// ** zdir as a zero terminated string holding the default directory,
// ** and pBuffer receiving the fully qualified path name selected.
// ** Ior is returned 0 if a good selection was made. The output
// ** pBuffer is only updated if a good selection is made.
{
  return ( pAskFile( &zcap, &zdir, &pBuffer, 0 ) );
}

BOOL AskSaveFile( char * zcap, char * zdir, char * pBuffer )
// *G Run the file open dialog with zcap as the caption (may be 0),
// ** zdir as a zero terminated string holding the default directory,
// ** and pBuffer receiving the fully qualified path name selected.
// ** Ior is returned 0 if a good selection was made. The output
// ** pBuffer is only updated if a good selection is made.
{
  return ( pAskFile( &zcap, &zdir, &pBuffer, 1 ) );
}


// ---- dump tool ----

char bchars[32];	// build byte value here

void make_szByte( char * src)
{
  unsigned char temp;
  
  bchars[0]=0;
  temp = *src;
  sprintf( bchars, "%02X ", temp );
}

void dumpline( char * line )
{
  void *ulltemp;
  int i;

  bchars[0]=0;
  ulltemp = (void *)line;
  sprintf( bchars, "%p ", ulltemp );	// %p is Microsoft
  strcat( destbuff, bchars );

  for( i=0; i<16; i++ )
  {
    make_szByte( line+i );
    strcat( destbuff, bchars ); 
  }
  strcat ( destbuff, "\n" );
}
  

void dump( void * start, int len )
{
  char *lltemp;

  destbuff = malloc( 0x100000 );
  destbuff[0]=0;
//  MessageBox( NULL, "into DUMP", "OFN", MB_OK );
  
  for ( lltemp=start; lltemp<(char *)(start+len); lltemp+=16 )
    dumpline( lltemp );

  MessageBox( NULL, destbuff, "OFN", MB_OK );
  
  free( destbuff );
}


/* Library setup/teardown calls */

void __attribute__ ((constructor)) my_init(void)
{
    /* Nothing to do yet! */
}

void __attribute__ ((destructor)) my_fini(void)
{
    /* Nothing to do yet! */
}


