\ PiCheck.fth - check if we are running on a Raspberry Pi

((
Copyright (c) 2014, 2016
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel:   +44 (0)23 8063 1441
email: mpe@mpeforth.com
       tech-support@mpeforth.com
web:   http://www.mpeforth.com
Skype: mpe_sfp

From North America, our telephone and fax numbers are:
       011 44 23 8063 1441
       011 44 23 8033 9691
       901 313 4312 (North American access number to UK office)


To do
=====

Change history
==============
20140814 SFP001 First cut.

The check is performed by reading /proc/cpuinfo line by line to
see if the CPU is a BCM2708 or BCM2835 as used in a Raspberry Pi.
))

only forth definitions
decimal

\ ===========
\ *> lintools
\ ===========

also system definitions

: checkPi	\ fid -- flag
  {: | temp[ 260 ] -- flag :}
  >r  begin				\ -- ; R: -- fid
    temp[ #256 r@ read-line		\ -- len res ior ; R: -- fid
    swap 0= or				\ -- len ior/EOF
    if  drop  r> drop  0 exit  endif
    temp[ over s" BCM2708" search nip nip	\ RPi 1
    if  drop  r> drop  -1 exit  endif
    temp[ over s" BCM2709" search nip nip	\ RPi 2
    if  drop  r> drop  -1 exit  endif
    temp[ over s" BCM2710" search nip nip	\ RPi 3
    if  drop  r> drop  -1 exit  endif
    temp[ over s" BCM2835" search nip nip
    if  drop r> drop  -1 exit endif
    temp[ over s" BCM2836" search nip nip
    if  drop r> drop  -1 exit endif
    temp[ over s" BCM2837" search nip nip
    if  drop r> drop  -1 exit endif
    drop
  again
;

: OnRPi?	\ -- flag ; true if running on a Raspberry Pi
  s" /proc/cpuinfo" r/o open-file
  if  drop 0 exit  endif
  dup checkPi
  swap close-file drop
;

: hwtest	\ --
  OnRpi? 0= if  bye  endif
;

previous definitions


\ ======
\ *> ###
\ ======

decimal
